<template>
    <div class="container d-flex flex-column align-items-center justify-content-center" style="height: 100vh;">
        <h2 class="my-4 login-card-title">Welcome To Movies App</h2>
        <div class="card login-card">
            <div class="card-header">
                <h4>Login</h4>
            </div>

            <div class="card-body">

                <ul class="alert alert-warning" v-if="Object.keys(this.errorList).length > 0">
                    <li class="mb-0 ms-3" v-for="(error, index) in this.errorList" :key="index">
                        {{ error[0] }}
                    </li>
                </ul>

                <div class="mb-3">
                    <label for="" class="mb-2">Email</label>
                    <input type="text" v-model="model.user.email" placeholder="Email" class="form-control" />
                </div>
                <div class="mb-3">
                    <label for="" class="mb-2">Password</label>
                    <input type="password" v-model="model.user.password" placeholder="Password" class="form-control" />
                </div>
                <div class="action-buttons-container mb-3">
                    <RouterLink :to="{ path: '/register' }" class="btn btn-primary auth-button mx-2">Create Account</RouterLink>
                    <button type="button" @click="login()" class="btn btn-success auth-button">Login</button>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import axios from 'axios';

export default {
    name: "login",
    data() {
        return {
            errorList: '',
            model: {
                user: {
                    email: '',
                    password: '',
                }
            }
        }
    },
    methods: {
        login() {
            var $this = this;
            console.log(this.model.user);

            axios.post('http://localhost:8000/api/login', this.model.user, {
                headers: {
                    'Accept': 'application/json'
                }
            }).then(res => {
                console.log(res.data);
                localStorage.setItem('token', 'Bearer ' + res.data.data.token);
                // alert(res.data.message);
                // empty the fields after added
                this.model.user = {
                    email: '',
                    password: '',
                }
                this.errorList = '';
                this.$router.push({ path: '/home' });
            }).catch(function (error) {
                if (error.response) {
                    // debugger;
                    if (error.response.status == 422) {
                        $this.errorList = error.response.data.errors;
                    } else if (error.response.status == 401) {
                        alert(error.response.data.message);
                    } else if (error.response.status == 500) {
                        alert(error.response.data.message);
                    }
                } else if (error.request) {
                    console.log(error.request);
                } else {
                    console.log('Error', error.message);
                }
            })
        }
    }
}
</script>

<style>
.login-card-title {
    color: white;
}

.login-card {
    width: 50vw;
}

.btn-primary,
.btn-primary:hover,
.btn-primary:focus-visible {
    background: #474646 !important;
    border-color: #474646 !important;
}

.auth-button{
    width: 9rem;
}

.action-buttons-container {
    float:right;
}
</style>

